unit ParentU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  end;

var
  Form1: TForm1;
  ChildAppID: Integer;

implementation

{$R *.DFM}

{$ifdef Win32}
type
  EWin32Error = class(Exception);

function LaunchChildApp: THandle;
const
  ChildApp = 'Child.Exe';
var
  SI: TStartupInfo;
  PI: TProcessInformation;
begin
  GetStartupInfo(SI);
  if not CreateProcess(nil, ChildApp, nil, nil, False,
     0, nil, nil, SI, PI) then
    raise EWin32Error.Create('Unable to launch ' + ChildApp);
  ChildAppID := PI.dwThreadID;
  Result := PI.HProcess
end;
{$else}
uses
  ToolHelp;

function LaunchChildApp: THandle;
const
  ChildApp = 'Child.Exe';
var
  TE: TTaskEntry;
begin
  Result := WinExec(ChildApp, sw_ShowNormal);
  if Result < HInstance_Error then
    raise Exception.Create('Unable to launch ' + ChildApp);
  FillChar(TE, SizeOf(TE), 0);
  TE.dwSize := SizeOf(TE);
  if TaskFirst(@TE) then
    repeat
      if TE.HInst = Result then
        ChildAppID := TE.HTask; { found 16-bit child }
      if TE.HModule = Result then
        ChildAppID := TE.HTask; { found 32-bit child }
    until not TaskNext(@TE);
  if ChildAppID = 0 then
    raise Exception.Create('Cannot locate task')
end;
{$endif}

procedure TForm1.Button1Click(Sender: TObject);
begin
  LaunchChildApp;
  Button1.Enabled := False;
  Button2.Enabled := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
{$ifdef Win32}
  PostThreadMessage(ChildAppID, wm_SysCommand, sc_Icon, 0);
{$else}
  PostAppMessage(ChildAppID, wm_SysCommand, sc_Icon, 0);
{$endif}
end;

end.
